/*****************************************************************************\
 * Vvoj okennho systmu ve WinAPI
 * Bakalsk prce 2006, 
 * Fakulta Informanch Technologi v Brn
 * 
 * SoWinMenu.h	
 *
 * SoWinMENU - SoWinMENU class
 *
 * Author: Dolej Petr (xdolej06 @ stud.fit.vutbr.cz)
 *         
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

#include <windows.h>
#ifndef _WIN32_MENU
#define _WIN32_MENU
#define MENU_MSG   WM_USER + 1000

class SoWinMENU
{
public: 
	    void Init(HWND hCizi,HWND MyWindow);
		void Init(HWND hCizi);
		HMENU CreateMenu(int,void (*)(int));
		HMENU CreateMenufromFile(char *Menu_file,void (*CALL)(int));
		HMENU CreateMDIMenu(int,void (*)(int));
		HMENU CreateMDIMenufromFile(char *Menu_file,void (*CALL)(int));
		void Close();
		void CloseAll();
		HMENU GetHMENU();
		BOOL ToggleMenuItemChecked(int);
		void (*CALLME)(int);
		SoWinMENU();
		~SoWinMENU();

private:
		HMODULE hInstance;
		HWND hWnd;
		HWND hMyWindow;
		HMODULE m_hDLL;
		HMENU hMenu;
		HMENU ReadMenuFromFile(char *Menu_file);
		BOOL HookMenu();
};

typedef BOOL (*tSetHooks)(HWND hWnd, int IdMsg);
typedef BOOL (*tRemoveHooks)(BOOL All);

#endif